<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目年度" prop="projectYear">
        <el-date-picker clearable size="small"
          v-model="queryParams.projectYear"
          type="year"
          value-format="yyyy-MM-dd"
          placeholder="选择工程项目年度">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="工程项目年度" align="center" prop="projectYear" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.projectYear, '{y}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="企业名称" align="center" prop="enterpriseCode" >
        <span slot-scope="scope" v-if="scope.row.enterpriseCode">{{scope.row.enterpriseCode}}</span>
        <span v-else>-</span>
      </el-table-column>
      <el-table-column label="门站数量(个)" align="center" prop="numberGateStations" />
      <el-table-column label="门站投资额(万元)" align="center" prop="gateStationInvestment">
        <span slot-scope="scope" v-if="scope.row.gateStationInvestment">{{scope.row.gateStationInvestment}}</span>
        <span v-else>-</span>
      </el-table-column>
      <el-table-column label="管道长度(米)" align="center" prop="pipeLength" />
      <el-table-column label="管道投资额(万元)" align="center" prop="pipeInvestment" >
        <span slot-scope="scope" v-if="scope.row.pipeInvestment">{{scope.row.pipeInvestment}}</span>
        <span v-else>-</span>
      </el-table-column>
      <el-table-column label="附件" align="center" prop="nearbyAddress" >
        <template slot-scope="scope">
          <span
            class="dbtn"
            @click="checkFile(scope.row.nearbyAddress)"
            v-if="scope.row.nearbyAddress"
          >
            <i class="el-icon el-icon-view"></i>查看/下载
          </span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改工程项目信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-row>
          <el-col :span="11">
             <el-form-item label="项目年度" prop="projectYear">
               <el-date-picker style="width: 100%"
                v-model="form.projectYear"
                type="year"
                placeholder="选择年"
                value-format="yyyy-MM-dd">
               </el-date-picker>
             </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="企业名称" prop="enterpriseCode">
              <el-input :disabled="true" v-model="form.enterpriseCode" placeholder="企业名称" >
              </el-input>
            </el-form-item>
          </el-col>
          </el-row>

        <div class="tableTitle">
          <img :src="stationImg" style="width: 24px; height: 25px;position: relative; left: -326px; top: -12px;"/>
          <span class="midText">门站</span>
        </div>
        <el-row>
            <el-col :span="11">
              <el-form-item label="门站数量" prop="numberGateStations">
                <el-input @change="numberGateStations()"  v-model="form.numberGateStations" placeholder="请输入门站数量" >
                  <template slot="append">个</template>
                </el-input>
              </el-form-item>
            </el-col>

            <el-col :span="12">
              <el-form-item label="门站投资额" prop="gateStationInvestment">
                <el-input :disabled="isGateStationDisabled" v-model="form.gateStationInvestment" placeholder="请输入门站投资额" >
                <template slot="append">万元</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>


        <div class="tableTitle">
          <img :src="bookImg" style="width: 24px; height: 25px;  position: relative;  left: -326px;  top: -12px;"/>
          <span class="midText">管道</span>
        </div>
          <el-row>
            <el-col :span="11">
              <el-form-item label="管道长度" prop="pipeLength">
                <el-input @change="conduitGateStations()" v-model="form.pipeLength" placeholder="请输入管道长度" >
                  <template slot="append">米</template>
                </el-input>
              </el-form-item>
            </el-col>

            <el-col :span="12">
              <el-form-item label="管道投资额" prop="pipeInvestment">
                <el-input :disabled="isPipelineAmount" v-model="form.pipeInvestment" placeholder="请输入管道投资额" >
                  <template slot="append">万元</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="23">
              <el-form-item label="附件" prop="nearbyAddress">
                <FileUpload
                  listType="picture"
                  @resFun="getFileInfo"
                  @remove="listRemove"
                  :fileArr="fileList"
                />
                <el-input v-show="false" disabled v-model="form.nearbyAddress"></el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="23">
              <el-form-item label="备注" prop="remarks">
                <el-input v-model="form.remarks" type="textarea" placeholder="请输入备注" />
              </el-form-item>
            </el-col>
          </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listInfo, getInfo, delInfo, addInfo, updateInfo, exportInfo } from "@/api/regulation/project";
import FileUpload from '@/components/FileUpload';

export default {
  name: "Info",
  components: {
    FileUpload,
  },
  data() {
    return {
      stationImg: require('@/assets/project/station.png'),
      bookImg: require('@/assets/project/theConduit.png'),
      // 上传文件列表
      fileList: [],
      //门站金额输入框是否输入
      isGateStationDisabled:true,
      //管道金额输入框是否输入
      isPipelineAmount:true,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 工程项目信息表格数据
      infoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        projectYear: null,
        gateStationInvestment: null,
        numberGateStations: null,
        pipeLength: null,
        pipeInvestment: null,
        nearbyAddress: null,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        projectYear: [
          { required: true, message: "请选择项目年度", trigger: "blur" },
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /**文件上传方法*/
    getFileInfo(res){
      this.form.dealPlan = res.fileName;
      this.form.nearbyAddress = res.url;
      this.fileList.push({
        name: res.fileName,
        url: uploadfile,
      });
    },
    listRemove(e) {
      this.form.dealPlan = "";
      this.fileList = [];
    },
    checkFile(url) {
      window.open(url,'_blank');
    },
    //门站数量输入框监听事件
    numberGateStations(){
      if (this.form.numberGateStations){
        this.isGateStationDisabled=false;
      }else {
        this.isGateStationDisabled=true;
      }
    },
    //管道数量输入框监听事件
    conduitGateStations(){
      if (this.form.pipeLength){
        this.isPipelineAmount=false;
      }else {
        this.isPipelineAmount=true;
      }
    },
    /** 查询工程项目信息列表 */
    getList() {
      this.loading = true;
      listInfo(this.queryParams).then(response => {
        this.infoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
      this.fileList = [];
    },
    // 表单重置
    reset() {
      this.form = {
        projectId: null,
        projectYear: null,
        gateStationInvestment: null,
        numberGateStations: 0,
        pipeLength: 0,
        pipeInvestment: null,
        nearbyAddress: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        isDel: null,
        remarks: null,
        enterpriseCode:null
      };
      this.resetForm("form");
      this.fileList = [];
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.projectId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      //门站金额输入框是否输入
      this.isGateStationDisabled=true,
      //管道金额输入框是否输入
      this.isPipelineAmount=true,
      this.reset();
      this.open = true;
      this.title = "添加工程项目信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const projectId = row.projectId || this.ids
      getInfo(projectId).then(response => {
        this.form = response.data;
        //文件回显
        if (this.form.nearbyAddress) {
          this.fileList.push({
            name: '附件',
            url: this.form.nearbyAddress,
          });
        }
        this.open = true;
        this.title = "修改工程项目信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.projectId != null) {
            updateInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            //循环查询出来的列表 与添加的年份是否有相同的
            let is_identical = 0;
            for (let i = 0; i < this.infoList.length; i++) {
              if (this.infoList[i].projectYear == this.form.projectYear) {
                is_identical = 1;
              }
            }
            //如果有相同的年份 弹出提示框 是否进行覆盖
            if (is_identical == 1) {
              this.$confirm('查询到已存在' + this.form.projectYear + '年份的数据，继续创建会自动覆盖之前的数据，是否创建', '警告', {
                 confirmButtonText: '确定',
                 cancelButtonText: '取消',
                 type: 'warning'
              }).then(() => {
                addInfo(this.form).then(response => {
                  this.msgSuccess("新增成功");
                  this.open = false;
                  this.getList();
                  this.reset();
                });
                }).catch(() => {
                 this.$message({
                   type: 'info',
                   message: '已取消'
                 });
                });
            }else {
              //没有年份相同的就执行添加方法
              addInfo(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
                this.reset();
              });
            }
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const projectIds = row.projectId || this.ids;
      this.$confirm('是否确认删除企业名称为"' + row.enterpriseCode + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfo(projectIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有工程项目信息数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfo(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
<style>
  .dbtn {
    display: inline-block;
    line-height: normal;
    padding-left: 2px;
    padding-right: 2px;
    cursor: pointer;
    border-radius: 3px;
    border-style: solid;
    border-width: 0;
    color: rgb(48, 180, 107);
  }
  .dbtn:hover {
    border-width: 1px;
    border-color: rgb(48, 180, 107);
  }
  .tableTitle {
    position: relative;
    margin: 24px  auto;
    width: 600px;
    height: 2px;
    background-color: #d4d4d4;
    text-align: center;
    font-size: 16px;
    color: rgba(101, 101, 101, 1);
  }
  .midText {
    position: absolute;
    left: 3%;
    background-color: #ffffff;
    padding: 0 15px;
    transform: translateX(-50%) translateY(-50%);
  }

</style>

